// FilMovieDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FilMovie.h"
#include "FilMovieDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define DEFAULT_BRIGHTTOP	(200.0)
#define DEFAULT_BRIGHTBOT	(100.0)
#define DEFAULT_BRIGHTSET	(160.0)

#define DEFAULT_MINPIXTOP	(170.0)
#define DEFAULT_MINPIXBOT	(20.0)
#define DEFAULT_MINPIXSET	(100.0)

#define DEFAULT_DARKFACTOP	(100.0)
#define DEFAULT_DARKFACBOT	(0.0)
#define DEFAULT_DARKFACSET	(10.0)

#define TIMER_MS			33


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CStatic	m_LastError;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LASTERROR, m_LastError);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFilMovieDlg dialog

CFilMovieDlg::CFilMovieDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFilMovieDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFilMovieDlg)
	m_ShowGroup = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFilMovieDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFilMovieDlg)
	DDX_Control(pDX, IDC_MARKMINPIX, m_MarkMinPix);
	DDX_Control(pDX, IDC_SHOWWRITE, m_ShowWrite);
	DDX_Control(pDX, IDC_BRIGHTNESS2, m_Brightness2);
	DDX_Control(pDX, IDC_PERCDARK, m_PercDark);
	DDX_Control(pDX, IDC_MINPIXTOP, m_MinPixTop);
	DDX_Control(pDX, IDC_MINPIXSLD, m_MinPixSld);
	DDX_Control(pDX, IDC_MINPIXSET, m_MinPixSet);
	DDX_Control(pDX, IDC_MINPIXBOT, m_MinPixBot);
	DDX_Control(pDX, IDC_DARKFACTOP, m_DarkFacTop);
	DDX_Control(pDX, IDC_DARKFACSLD, m_DarkFacSld);
	DDX_Control(pDX, IDC_DARKFACSET, m_DarkFacSet);
	DDX_Control(pDX, IDC_DARKFACBOT, m_DarkFacBot);
	DDX_Control(pDX, IDC_BRIGHTTOP, m_BrightTop);
	DDX_Control(pDX, IDC_BRIGHTBOT, m_BrightBot);
	DDX_Control(pDX, IDC_BRIGHTSET, m_BrightSet);
	DDX_Control(pDX, IDC_BRIGHTSLD, m_BrightSld);
	DDX_Control(pDX, IDC_BRIGHTNESS, m_BrightnessOut);
	DDX_Control(pDX, IDC_DOMANIP, m_DoManip);
	DDX_Control(pDX, IDC_IMAGE, m_Image);
	DDX_Control(pDX, IDC_FRAMETIME, m_FrameTime);
	DDX_Control(pDX, IDC_FRAMENUM, m_FrameNum);
	DDX_Control(pDX, IDC_OUTFILE, m_Outfile);
	DDX_Control(pDX, IDC_INFILE, m_Infile);
	DDX_Radio(pDX, IDC_SHOWWRITE, m_ShowGroup);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFilMovieDlg, CDialog)
	//{{AFX_MSG_MAP(CFilMovieDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_INBROWSE, OnInbrowse)
	ON_BN_CLICKED(IDC_OUTBROWSE, OnOutbrowse)
	ON_EN_KILLFOCUS(IDC_INFILE, OnChangeInfile)
	ON_EN_KILLFOCUS(IDC_OUTFILE, OnChangeOutfile)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_FREEPLAY, OnFreeplay)
	ON_BN_CLICKED(IDC_SKIP, OnSkip)
	ON_EN_KILLFOCUS(IDC_BRIGHTTOP, OnChangeBrighttop)
	ON_EN_KILLFOCUS(IDC_BRIGHTBOT, OnChangeBrightbot)
	ON_EN_KILLFOCUS(IDC_BRIGHTSET, OnChangeBrightset)
	ON_WM_VSCROLL()
	ON_EN_KILLFOCUS(IDC_MINPIXTOP, OnChangeMinpixtop)
	ON_EN_KILLFOCUS(IDC_MINPIXSET, OnChangeMinpixset)
	ON_EN_KILLFOCUS(IDC_MINPIXBOT, OnChangeMinpixbot)
	ON_EN_KILLFOCUS(IDC_DARKFACTOP, OnChangeDarkfactop)
	ON_EN_KILLFOCUS(IDC_DARKFACSET, OnChangeDarkfacset)
	ON_EN_KILLFOCUS(IDC_DARKFACBOT, OnChangeDarkfacbot)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SHOWWRITE, OnShowwrite)
	ON_BN_CLICKED(IDC_SHOWREAD, OnShowread)
	ON_BN_CLICKED(IDC_DOMANIP, OnDomanip)
	ON_BN_CLICKED(IDC_MARKMINPIX, OnMarkminpix)
	ON_EN_CHANGE(IDC_FRAMENUM, OnChangeFramenum)
	ON_EN_KILLFOCUS(IDC_FRAMENUM, OnKillfocusFramenum)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFilMovieDlg message handlers

BOOL CFilMovieDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	FreePlayMode = FALSE;

	mReader = new MovieReader;
	mWriter = new MovieWriter;
	mManipulator = new Manipulator(mWriter);
	mDisplay = new PicDisplay(this, &m_Image);

	mBrightnessCtrl = new DblSlider;
	mMinPixCtrl = new DblSlider;
	mDarkFacCtrl = new DblSlider;

	mBrightnessCtrl->Init(&m_BrightTop, &m_BrightBot, &m_BrightSet, &m_BrightSld,
		DEFAULT_BRIGHTTOP, DEFAULT_BRIGHTBOT, DEFAULT_BRIGHTSET);
	mMinPixCtrl->Init(&m_MinPixTop, &m_MinPixBot, &m_MinPixSet, &m_MinPixSld,
		DEFAULT_MINPIXTOP, DEFAULT_MINPIXBOT, DEFAULT_MINPIXSET);
	mDarkFacCtrl->Init(&m_DarkFacTop, &m_DarkFacBot, &m_DarkFacSet, &m_DarkFacSld,
		DEFAULT_DARKFACTOP, DEFAULT_DARKFACBOT, DEFAULT_DARKFACSET);

	CheckDlgButton(IDC_SHOWREAD, BST_CHECKED);
	OnShowwrite();

	m_DoManip.SetCheck(BST_UNCHECKED);
	OnDomanip();

	AdjustManipulator();

	mDisplay->ShowFrame(NULL, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFilMovieDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFilMovieDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFilMovieDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFilMovieDlg::OnInbrowse() 
{
	char strFilter[] = { "Windows Media files (*.wmv)|*.wmv|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(TRUE, ".wmv", NULL, 0, strFilter);

	if( FileDlg.DoModal() == IDOK )
	{
		CString	fullname=FileDlg.GetPathName();
		m_Infile.SetWindowText(fullname);
		OnChangeInfile();
	}
}

void CFilMovieDlg::OnOutbrowse() 
{
	char strFilter[] = { "Windows Media files (*.wmv)|*.wmv|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(TRUE, ".wmv", NULL, 0, strFilter);

	if( FileDlg.DoModal() == IDOK )
	{
		CString	fullname=FileDlg.GetPathName();
		m_Outfile.SetWindowText(fullname);
		OnChangeOutfile();
	}
}


// The input file has changed.  Load it up.
void CFilMovieDlg::OnChangeInfile() 
{
	CString	fullname;

	m_Infile.GetWindowText(fullname);
	mReader->SetInfile(fullname);
	mWriter->InitProfile(mReader->GetProfile());
}


// The output file has changed.  Ready to save.
void CFilMovieDlg::OnChangeOutfile() 
{
	CString	fullname;

	m_Outfile.GetWindowText(fullname);
	mWriter->SetOutfile(fullname);
}


// #### Make a popup
void Ding(char *msg, HRESULT hr) {
	static HRESULT	nhr=0;
	nhr=hr;		// Just to give something to stop on
}



void CFilMovieDlg::OnNext() 
{
	int			thisframe;
	double		thistime,thisbright;
	double		outbright,percdark;
	CString		dispval="";
	INSSBuffer	*readSample;
	BITMAPINFO	*readInfo;
	BITMAPINFO	*dispInfo;
	BYTE		*dispMap;
	HRESULT		hr;

	thisframe = mReader->NextFrame();
	dispval.Format("%d", thisframe);
	m_FrameNum.SetWindowText(dispval);
	m_FrameNum.RedrawWindow();

	thistime = mReader->GetFrameTime();
	dispval.Format("%e", thistime);
	m_FrameTime.SetWindowText(dispval);
	m_FrameTime.RedrawWindow();

	hr = mReader->GetFrame(&readSample, &readInfo);

	if (FAILED(hr)) {
		FreePlayMode = FALSE;
		mWriter->Close();
	}
	else {
		mManipulator->ModifyFrame(readSample, readInfo, &dispInfo, &dispMap);

		thisbright=mManipulator->GetBrightness(&outbright, &percdark);
		dispval.Format("%e", thisbright);
		m_BrightnessOut.SetWindowText(dispval);
		m_BrightnessOut.RedrawWindow();
		dispval.Format("%e", outbright);
		m_Brightness2.SetWindowText(dispval);
		m_Brightness2.RedrawWindow();
		dispval.Format("%e", percdark*100.0);
		m_PercDark.SetWindowText(dispval);
		m_PercDark.RedrawWindow();
		
		mDisplay->ShowFrame(dispInfo, dispMap);
	}
}

void CFilMovieDlg::OnFreeplay() 
{
	if (FreePlayMode) FreePlayMode = FALSE;
	else {
		FreePlayMode = TRUE;
		SetTimer(0, TIMER_MS, NULL);
	}
}

void CFilMovieDlg::OnSkip() 
{
	INSSBuffer	*readSample;
	BITMAPINFO	*readInfo;

	for (int i=0; i<100; i++) {
		mReader->NextFrame();
		mReader->GetFrame(&readSample, &readInfo);
		SAFE_RELEASE(readSample);
	}
}

void CFilMovieDlg::AdjustManipulator() {
	mManipulator->NewParams(mBrightnessCtrl->GetVal(), mMinPixCtrl->GetVal(), mDarkFacCtrl->GetVal());
}

void CFilMovieDlg::OnChangeBrighttop() 
{
	mBrightnessCtrl->LimitsChanged();
	AdjustManipulator();
}

void CFilMovieDlg::OnChangeBrightbot() 
{
	mBrightnessCtrl->LimitsChanged();
	AdjustManipulator();
}

void CFilMovieDlg::OnChangeBrightset() 
{
	mBrightnessCtrl->SetChanged();	
	AdjustManipulator();
}

void CFilMovieDlg::OnChangeMinpixtop() 
{
	mMinPixCtrl->LimitsChanged();
	AdjustManipulator();
}

void CFilMovieDlg::OnChangeMinpixbot() 
{
	mMinPixCtrl->LimitsChanged();
	AdjustManipulator();
}

void CFilMovieDlg::OnChangeMinpixset() 
{
	mMinPixCtrl->SetChanged();
	AdjustManipulator();
}

void CFilMovieDlg::OnChangeDarkfactop() 
{
	mDarkFacCtrl->LimitsChanged();
	AdjustManipulator();
}

void CFilMovieDlg::OnChangeDarkfacbot() 
{
	mDarkFacCtrl->LimitsChanged();
	AdjustManipulator();
}

void CFilMovieDlg::OnChangeDarkfacset() 
{
	mDarkFacCtrl->SetChanged();
	AdjustManipulator();
}

void CFilMovieDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	HWND	inWnd=pScrollBar->GetSafeHwnd();
	
	if (inWnd==m_BrightSld.GetSafeHwnd()) {
		mBrightnessCtrl->SliderChanged();
		AdjustManipulator();
	}
	else if (inWnd==m_MinPixSld.GetSafeHwnd()) {
		mMinPixCtrl->SliderChanged();
		AdjustManipulator();
	}
	else if (inWnd==m_DarkFacSld.GetSafeHwnd()) {
		mDarkFacCtrl->SliderChanged();
		AdjustManipulator();
	}
	else CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}



void CFilMovieDlg::OnTimer(UINT nIDEvent) 
{
	KillTimer(0);
	if (FreePlayMode) {
		OnNext();
		SetTimer(0, TIMER_MS, NULL);
	}
}

void CFilMovieDlg::OnShowwrite() 
{
	mManipulator->SetDisp(m_ShowWrite.GetState() & 3);
}


void CFilMovieDlg::OnShowread() 
{
	OnShowwrite();
}

void CFilMovieDlg::OnDomanip() 
{
	mManipulator->SetManip(m_DoManip.GetState() & 3);
}

void CFilMovieDlg::OnMarkminpix() 
{
	mManipulator->SetMarkMinPix(m_MarkMinPix.GetState() & 3);
}


void CFilMovieDlg::OnChangeFramenum() 
{
}

// #### Only works for forward movement
void CFilMovieDlg::OnKillfocusFramenum() 
{
	CString	s;
	int		newframe,oldframe,move,i;
	INSSBuffer	*readSample;
	BITMAPINFO	*readInfo;

	newframe = oldframe = mReader->GetFrameNum();

	m_FrameNum.GetWindowText(s);
	if (s!="") newframe = atof(s);

	move = newframe-oldframe;
	if (move <= 0) return;

	for (i=0; i<move; i++) {
		mReader->NextFrame();
		mReader->GetFrame(&readSample, &readInfo);
		SAFE_RELEASE(readSample);
	}
}
