
#include "stdafx.h"


class MovieReader {
public:
	MovieReader();
	~MovieReader();
	
	HRESULT SetInfile(CString &filename);
	int NextFrame(void);
	int PrevFrame(void);

	int SetFrameNum(int newnum);
	int SetFrameTime(double newtime);

	RECT GetFrameRect(void);
	int GetFrameNum(void);
	double GetFrameTime(void);
	double GetFramesPerSec(void);

	HRESULT GetFrame(INSSBuffer **outSample, BITMAPINFO **outInfo);

	IWMProfile *GetProfile() { return(mProfile); }

private:
	HRESULT Open(const WCHAR *filename);
	HRESULT Close(void);
	HRESULT GetStreamNumbers(void);
	HRESULT ReadFrame(void);

	IWMSyncReader		*mSyncReader;
	IWMProfile			*mProfile;
	IWMMediaProps		*mProps;
	WM_MEDIA_TYPE		*mMedia;
	WMVIDEOINFOHEADER	*mVideo;
	INSSBuffer			*mSample;
	

	WORD		VideoStreamNum;
	BOOL		Compressed;

	BOOL		TimeSyncd;
	DWORD		FrameOutputNum;
	DWORD		FrameFlags;
	int			FrameNum;
	double		FrameTime;
	double		FramesPerSec;
	double		FrameDuration;
};



